<?php

if( !class_exists( 'umSetEmailController' ) ) :
    class umSetEmailController {
        
        function __construct() {
            global $userMeta;
            if( !is_object( $userMeta ) ) return;
                                      
            add_action( 'admin_menu', array( $this, 'admin_menu' )); 
            add_action( 'user_meta_after_user_register', array( $this, 'emailTemplate' )); 
        }
        

        function admin_menu(){
            global $userMeta;
            $page = add_submenu_page( 'usermeta', 'Email', 'Email', 'manage_options', 'user-meta-email', array( $this, 'init' ));                        

            $userMeta->addScript( 'plugin-framework.js',  'admin', $page );
            $userMeta->addScript( 'plugin-framework.css', 'admin', $page );
            $userMeta->addScript( 'user-meta.js',         'admin', $page ); 
            $userMeta->addScript( 'user-meta.css',        'admin', $page ); 
        }  
        
        function init(){
            global $userMeta;   
                                    
            $this->saveSetting();
                                   
            $data = get_option( 'user-meta-email' );

            $adminEmail = $userMeta->createInput( 'admin_email[address]', 'text', array( 
                'label' => 'Admin Email Address',   
                'value' => @$data['admin_email']['address'], 
                'style' => 'width:300px',
            ) );            
            $adminEmail .= $userMeta->createInput( 'admin_email[subject]', 'text', array( 
                'label' => 'Email Subject',   
                'value' => @$data['admin_email']['subject'], 
                'style' => 'width:70%',
            ) );            
            $adminEmail .= $userMeta->createInput( 'admin_email[body]', 'textarea', array( 
                'label' => 'Email Body',   
                'value' => @$data['admin_email']['body'], 
                'style' => 'width:70%;height:300px;', 
            ) );     
            $adminEmail .= $userMeta->createInput( 'admin_email[enable]', 'checkbox', array( 
                'label' => 'Enable Admin Email',   
                'value' => @$data['admin_email']['enable'],  
            ) );             
            
            
            $userEmail = $userMeta->createInput( 'user_email[subject]', 'text', array( 
                'label' => 'Email Subject',   
                'value' => @$data['user_email']['subject'], 
                'style' => 'width:70%',
            ) );            
            $userEmail .= $userMeta->createInput( 'user_email[body]', 'textarea', array( 
                'label' => 'Email Body',   
                'value' => @$data['user_email']['body'], 
                'style' => 'width:70%;height:300px;', 
            ) );       
            $userEmail .= $userMeta->createInput( 'user_email[enable]', 'checkbox', array( 
                'label' => 'Enable User Email',   
                'value' => @$data['user_email']['enable'],  
            ) );                           
            
            ?>
            <div class="wrap">
                <div id="icon-options-general" class="icon32 icon32-posts-page"><br /></div>  
                <h2>User Meta Settings</h2>   
                <?php //do_action( 'um_admin_notice' ); ?>
                <div id="dashboard-widgets-wrap">
                    <div class="metabox-holder">
                        <div id="um_admin_content">
                            <form method="post" action="" >
                            <?php echo $userMeta->metaBox("Admin Email", $adminEmail); ?>
                            <?php echo $userMeta->metaBox("User Email", $userEmail); ?>
                            <input type="submit" name="save_settings" class="button-primary" value="Save Email Templete" />
                            </form>
                        </div>
                        
                        <div id="um_admin_sidebar">                            
                            <?php
                            $variable = "<p>%BLOG_TITLE%</p>";
                            $variable .= "<p>%BLOG_URL%</p>";
                            $variable .= "<p>%USER_LOGIN%</p>";
                            $variable .= "<p>%USER_EMAIL%</p>";
                            $variable .= "<p>%PASSWORD%</p>";
                            $variable .= "<p>%DISPLAY_NAME%</p>";
                            $variable .= "<p>%FIRST_NAME%</p>";
                            $variable .= "<p>%LAST_NAME%</p>";
                            $variable .= "<p>%YOUR_META_KEY%</p>";
                            $variable .= "<p></p>";
                            $variable .= "<p style='color:red'>This is a temporary solution for user email notification. This feature will be updated soon</p>";
                            echo $userMeta->metaBox( 'Variable', $variable );
                            ?>
                        </div>
                    </div>
                </div>     
            </div> 
            <?           
            
        }
        
        function saveSetting(){
            global $userMeta;
            
            if( !isset( $_REQUEST['save_settings'] ) ) return;
            
            update_option( 'user-meta-email', $_REQUEST );
            echo $userMeta->showMessage( 'Setting Saved!' );           
        }
        
        function emailTemplate( $userdata ){
            $data = get_option( 'user-meta-email' );
            
            $user = new WP_User( $userdata->ID );
            $user->password = $userdata->user_pass;
            
            if( @$data['admin_email']['address'] && @$data['admin_email']['enable'] ){
                wp_mail( $data['admin_email']['address'], $this->filterContent( $user, $data['admin_email']['subject'] ), $this->filterContent( $user, $data['admin_email']['body'] ) );
            }
            
            if( @$data['user_email']['enable'] )
                wp_mail( $user->user_email, $this->filterContent( $user, $data['user_email']['subject'] ), $this->filterContent( $user, $data['user_email']['body'] ) );
        
        }
        
        
        function filterContent( $user, $data ){             
            preg_match_all( '/\%[a-zA-Z0-9_-]+\%/i', $data, $matches); 
            if( is_array( @$matches[0] ) ){
                $patterns = $matches[0];
                $replacements = array();
                foreach( $patterns as $key => $pattern ){
                    $fieldName = strtolower( trim( $pattern, '%' ) );
                    if( $fieldName == 'blog_title' )
                        $replacements[ $key ] = get_bloginfo( 'name' );
                    elseif( $fieldName == 'blog_url' )
                        $replacements[ $key ] = site_url();
                    else
                        $replacements[ $key ] = @$user->$fieldName;
                }
                $data = str_replace($patterns, $replacements, $data);
            }    

            return $data;     
        }      
               
    }
    
endif;

?>